Index: code/trunk/src/libraries/core/singleton/Scope.h
===================================================================
--- code/trunk/src/libraries/core/singleton/Scope.h	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/Scope.h	(revision 10624)
@@ -0,0 +1,133 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@ingroup SingletonScope
+@brief Declaration of the classes that are needed to use Scopes: orxonox::Scope and orxonox::ScopeListener.
+
+@anchor Scope
+
+A virtual scope can be represented by an instance of class orxonox::Scope. orxonox::Scope<@a scope> is a template
+an its template argument defines the name of the virtual scope. See orxonox::ScopeID for an enumeration of the
+available values for @a scope. The orxonox::Scope object for a given @a scope can be activated or deactivated.
+Instances of orxonox::ScopeListener can register in orxonox::ScopeMAnager for a given @a scope and will get a
+notification if the corresponding orxonox::Scope object changes its state.
+
+Scopes are usually used to control the creation and destruction of Singletons.
+
+@see orxonox::Singleton
+*/
+
+#ifndef __Core_Scope_H__
+#define __Core_Scope_H__
+
+#include "core/CorePrereqs.h"
+
+#include <cassert>
+#include <map>
+#include <set>
+#include <loki/ScopeGuard.h>
+
+#include "util/Output.h"
+#include "ScopeManager.h"
+
+namespace orxonox
+{
+    /**
+        @brief ScopeListeners register themselves in the corresponding Scope and wait for notifications.
+        Notifications are sent if a Scope is activated or deactivated.
+
+        @see See @ref Scope "this description" for details about the interrelationship of Scope, ScopeListener, and ScopeManager.
+    */
+    class _CoreExport ScopeListener
+    {
+        friend class ScopeManager;
+
+        protected:
+            ScopeListener() : bActivated_(false) { }
+            virtual ~ScopeListener() { }
+
+            //! Gets called if the scope is activated
+            virtual void activated() = 0;
+            //! Gets called if the scope is deactivated
+            virtual void deactivated() = 0;
+
+        private:
+            bool bActivated_;
+    };
+
+    /**
+        @brief A scope for a given template argument is either active or not.
+
+        Objects inheriting from a ScopeListener are registered in a list (different for each scope).
+        If the scope gets activated or deactivated, all objects in this list are notified.
+
+        @see See @ref Scope "this description" for details about the interrelationship of Scope, ScopeListener, and ScopeManager.
+    */
+    template <ScopeID::Value scope>
+    class Scope
+    {
+        public:
+            //! Constructor: activate the listeners.
+            Scope()
+            {
+                orxout(internal_status) << "creating scope... (" << scope << ")" << endl;
+
+                Loki::ScopeGuard deactivator = Loki::MakeObjGuard(*this, &Scope::deactivateScope);
+                ScopeManager::getInstance().addScope(scope);
+                deactivator.Dismiss();
+
+                orxout(internal_status) << "created scope (" << scope << ")" << endl;
+            }
+
+            //! Destructor: deactivate the listeners.
+            ~Scope()
+            {
+                orxout(internal_status) << "destroying scope... (" << scope << ")" << endl;
+
+                this->deactivateScope();
+
+                orxout(internal_status) << "destroyed scope (" << scope << ")" << endl;
+            }
+
+            //! Deactivates the listeners of this scope in case the scope is destroyed or the construction fails.
+            void deactivateScope()
+            {
+                ScopeManager::getInstance().removeScope(scope);
+            }
+
+            //! Returns true if the scope is active.
+            static bool isActive()
+            {
+                return ScopeManager::getInstance().isActive(scope);
+            }
+    };
+}
+
+#endif /* __Core_Scope_H__ */
Index: code/trunk/src/libraries/core/singleton/ScopeManager.cc
===================================================================
--- code/trunk/src/libraries/core/singleton/ScopeManager.cc	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/ScopeManager.cc	(revision 10624)
@@ -0,0 +1,102 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of orxonox::ScopeManager.
+*/
+
+#include "ScopeManager.h"
+
+#include "Scope.h"
+
+namespace orxonox
+{
+    ScopeManager* ScopeManager::singletonPtr_s = 0;
+
+    void ScopeManager::addScope(ScopeID::Value scope)
+    {
+        this->activeScopes_.insert(scope);
+        this->activateListenersForScope(scope);
+    }
+
+    void ScopeManager::removeScope(ScopeID::Value scope)
+    {
+        this->activeScopes_.erase(scope);
+        this->deactivateListenersForScope(scope);
+    }
+
+    bool ScopeManager::isActive(ScopeID::Value scope)
+    {
+        return this->activeScopes_.find(scope) != this->activeScopes_.end();
+    }
+
+    void ScopeManager::addListener(ScopeListener* listener, ScopeID::Value scope)
+    {
+        this->listeners_[scope].insert(listener);
+        if (this->isActive(scope))
+            this->activateListener(listener);
+    }
+
+    void ScopeManager::removeListener(ScopeListener* listener, ScopeID::Value scope)
+    {
+        if (this->isActive(scope))
+            this->deactivateListener(listener);
+        this->listeners_[scope].erase(listener);
+    }
+
+    void ScopeManager::activateListenersForScope(ScopeID::Value scope)
+    {
+        for (std::set<ScopeListener*>::iterator it = this->listeners_[scope].begin(); it != this->listeners_[scope].end(); ++it)
+            this->activateListener(*it);
+    }
+
+    void ScopeManager::deactivateListenersForScope(ScopeID::Value scope)
+    {
+        for (std::set<ScopeListener*>::iterator it = this->listeners_[scope].begin(); it != this->listeners_[scope].end(); ++it)
+            this->deactivateListener(*it);
+    }
+
+    void ScopeManager::activateListener(ScopeListener* listener)
+    {
+        listener->activated();
+        listener->bActivated_ = true;
+    }
+
+    void ScopeManager::deactivateListener(ScopeListener* listener)
+    {
+        if (listener->bActivated_)
+        {
+            try
+                { listener->deactivated(); }
+            catch (...)
+                { orxout(internal_warning) << "ScopeListener::deactivated() failed! This MUST NOT happen, fix it!" << endl; }
+            listener->bActivated_ = false;
+        }
+    }
+}
Index: code/trunk/src/libraries/core/singleton/ScopeManager.h
===================================================================
--- code/trunk/src/libraries/core/singleton/ScopeManager.h	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/ScopeManager.h	(revision 10624)
@@ -0,0 +1,87 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@ingroup SingletonScope
+@brief Declaration of orxonox::ScopeManager.
+*/
+
+#ifndef __ScopeManager_H__
+#define __ScopeManager_H__
+
+#include "core/CorePrereqs.h"
+
+#include <map>
+#include <set>
+
+#include "util/Singleton.h"
+
+namespace orxonox
+{
+    /**
+        @brief The ScopeManager stores the variables of the Scope templates in a statically linked context.
+
+        If all Scope objects are managed by this class, they are statically linked in the core library.
+        Without this, a new instance of Scope<T> for each T would be created in every library of Orxonox,
+        which is of course not the desired behavior.
+
+        @see See @ref Scope "this description" for details about the interrelationship of Scope, ScopeListener, and ScopeManager.
+    */
+    class _CoreExport ScopeManager : public Singleton<ScopeManager>
+    {
+        friend class Singleton<ScopeManager>;
+
+        public:
+            /** Adds a scope and activates all listeners which are registered for this scope */
+            void addScope(ScopeID::Value scope);
+            /** Removes a scope and deactivates all listeners which are registered for this scope */
+            void removeScope(ScopeID::Value scope);
+            /** Returns true if this scope is active */
+            bool isActive(ScopeID::Value scope);
+
+            /** Registers a listener for the given scope. If the scope is already active, the listener is activate immediately. */
+            void addListener(ScopeListener* listener, ScopeID::Value scope);
+            /** Unregisters a listener for the given scope. If the scope is still active, the listener is deactivated before removal. */
+            void removeListener(ScopeListener* listener, ScopeID::Value scope);
+
+        private:
+            void activateListenersForScope(ScopeID::Value scope);
+            void deactivateListenersForScope(ScopeID::Value scope);
+
+            void activateListener(ScopeListener* listener);
+            void deactivateListener(ScopeListener* listener);
+
+            std::set<ScopeID::Value> activeScopes_;
+            std::map<ScopeID::Value, std::set<ScopeListener*> > listeners_; //!< Stores all listeners for a scope
+
+            static ScopeManager* singletonPtr_s;
+    };
+}
+
+#endif /* __ScopeManager_H__ */
Index: code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.cc
===================================================================
--- code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.cc	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.cc	(revision 10624)
@@ -0,0 +1,42 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "ScopedSingletonIncludes.h"
+
+namespace orxonox
+{
+    void StaticallyInitializedScopedSingletonWrapper::load()
+    {
+        ScopeManager::getInstance().addListener(this->wrapper_, this->scope_);
+    }
+
+    void StaticallyInitializedScopedSingletonWrapper::unload()
+    {
+        ScopeManager::getInstance().removeListener(this->wrapper_, this->scope_);
+    }
+}
Index: code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.h
===================================================================
--- code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.h	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/ScopedSingletonIncludes.h	(revision 10624)
@@ -0,0 +1,103 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup SingletonScope
+    @brief Definition of the ManageScopedSingleton macro.
+*/
+
+#ifndef __ScopedSingletonIncludes_H__
+#define __ScopedSingletonIncludes_H__
+
+#include "core/CorePrereqs.h"
+
+#include "ScopedSingletonWrapper.h"
+#include "core/module/StaticallyInitializedInstance.h"
+
+/**
+    @brief Creates an orxonox::ScopedSingletonWrapper for an orxonox::Singleton and registers it with orxonox::ScopeManager.
+    @param className The name of the singleton class
+    @param scope The scope in which the singleton should exist
+    @param allowedToFail If true, the singleton is allowed to fail and thus a try-catch block is used when creating the singleton.
+
+    If this macro is called for a singleton, it is wrapped in a ScopedSingletonWrapper and registered with ScopeManager
+    and will thus be created if its scope becomes active and destroyed if is deactivated.
+
+
+    Usually a singleton gets created automatically when it is first used, but it will never
+    be destroyed (unless the singleton explicitly deletes itself). To allow controlled
+    construction and destruction, the singleton can be put within a virtual scope. This is
+    done by registering the singleton class with orxonox::ScopeManager. To
+    do so, the ManageScopedSingleton() macro has to be called:
+
+    @code
+    ManageScopedSingleton(TestSingleton, ScopeID::Graphics, false); // muste be called in a source (*.cc) file
+    @endcode
+
+    @b Important: If you call ManageScopedSingleton(), you don't have to initialize singletonPtr_s anymore,
+    because that's already done by the macro.
+
+    Now the singleton TestSingleton gets automatically created if the scope Graphics becomes
+    active and also gets destroyed if the scope is deactivated.
+
+    Note that not all singletons must register with a scope, but it's recommended.
+
+*/
+#define ManageScopedSingleton(className, scope, allowedToFail) \
+    className* className::singletonPtr_s = NULL; \
+    static ScopedSingletonWrapper& className##ScopedSingletonWrapper \
+        = (new orxonox::SI_SSW(new ClassScopedSingletonWrapper<className, allowedToFail>(#className), scope))->getWrapper()
+
+namespace orxonox
+{
+    class _CoreExport StaticallyInitializedScopedSingletonWrapper : public StaticallyInitializedInstance
+    {
+        public:
+            StaticallyInitializedScopedSingletonWrapper(ScopedSingletonWrapper* wrapper, ScopeID::Value scope)
+                : StaticallyInitializedInstance(StaticInitialization::SCOPED_SINGLETON_WRAPPER)
+                , wrapper_(wrapper)
+                , scope_(scope)
+            {}
+            ~StaticallyInitializedScopedSingletonWrapper() { delete wrapper_; }
+
+            virtual void load();
+            virtual void unload();
+
+            inline ScopedSingletonWrapper& getWrapper()
+                { return *this->wrapper_; }
+
+        private:
+            ScopedSingletonWrapper* wrapper_;
+            ScopeID::Value scope_;
+    };
+
+    typedef StaticallyInitializedScopedSingletonWrapper SI_SSW;
+}
+
+#endif /* __ScopedSingletonIncludes_H__ */
Index: code/trunk/src/libraries/core/singleton/ScopedSingletonWrapper.h
===================================================================
--- code/trunk/src/libraries/core/singleton/ScopedSingletonWrapper.h	(revision 10624)
+++ code/trunk/src/libraries/core/singleton/ScopedSingletonWrapper.h	(revision 10624)
@@ -0,0 +1,196 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup SingletonScope
+    @brief Definition of orxonox::ScopedSingletonWrapper and orxonox::ClassScopedSingletonWrapper.
+
+    ScopedSingletonWrapper is used to create and destroy Singletons that belong to
+    a given Scope. For each one of these singletons, the macro ManageScopedSingleton()
+    has to be called to register the wrapper with orxonox::ScopeManager.
+
+    See @ref SingletonExample "this code" for an example.
+
+    @see orxonox::Singleton
+    @see orxonox::Scope
+*/
+
+#ifndef __ScopedSingletonWrapper_H__
+#define __ScopedSingletonWrapper_H__
+
+#include "core/CorePrereqs.h"
+
+#include <cassert>
+#include "util/Exception.h"
+#include "util/Singleton.h"
+#include "Scope.h"
+
+namespace orxonox
+{
+    /**
+        @brief Base class of ClassScopedSingletonWrapper.
+    */
+    class _CoreExport ScopedSingletonWrapper : public ScopeListener
+    {
+        public:
+            /// Constructor: Initializes all the values
+            ScopedSingletonWrapper(const std::string& className)
+                : className_(className)
+            { }
+            virtual ~ScopedSingletonWrapper() { }
+
+        protected:
+            const std::string className_;   ///< The name of the scoped singleton class that is managed by this object
+    };
+
+    /**
+        @anchor ClassScopedSingletonWrapper
+
+        @brief Manages a scoped singleton
+        @param T The managed singleton class
+        @param allowedToFail If true, a specialization of this template is used, that uses try-catch blocks to handle possible failures.
+
+        This class inherits from ScopeListener and is registered for a scope in ScopeManager and thus its functions
+        activated() and deactivated() are called whenever the Scope changes its state.
+
+        If the Scope is activated, a new instance of @a T (which must be a singleton) is created.
+        If the Scope is deactivated, the singleton is destroyed.
+
+        @see Singleton
+    */
+    template <class T, bool allowedToFail>
+    class ClassScopedSingletonWrapper : public ScopedSingletonWrapper
+    {
+    public:
+        ClassScopedSingletonWrapper(const std::string& className)
+            : ScopedSingletonWrapper(className)
+            , singletonPtr_(NULL)
+        {
+        }
+
+        ~ClassScopedSingletonWrapper()
+        {
+            if (singletonPtr_)
+                this->destroy(singletonPtr_);
+        }
+
+        //! Called if the Scope of the Singleton gets active (creates the instance)
+        void activated()
+        {
+            assert(singletonPtr_ == NULL);
+            singletonPtr_ = new T();
+        }
+
+        //! Called if the Scope of this Singleton gets deactivated (destroys the instance)
+        void deactivated()
+        {
+            assert(singletonPtr_ != NULL);
+            this->destroy(singletonPtr_);
+            singletonPtr_ = NULL;
+        }
+
+        //! Destroys the singleton instance - overloaded for Destroyable, calls Destroyable::destroy()
+        void destroy(Destroyable*)
+        {
+            singletonPtr_->destroy();
+        }
+        //! Destroys the singleton instance - overloaded for all other pointers, calls delete
+        void destroy(void*)
+        {
+            delete singletonPtr_;
+        }
+
+    private:
+        T* singletonPtr_;   ///< Unique instance of the singleton class @a T
+    };
+
+    /**
+        @brief This class partially spezializes ClassScopedSingletonWrapper for classes @a T that are allowed to fail.
+        @param T The managed singleton class
+
+        Because @a T could fail when being created, this partial spezialization of ClassScopedSingletonWrapper
+        uses a try-catch block to handle exceptions.
+
+        See @ref ClassScopedSingletonWrapper for a full documentation of the basis template.
+    */
+    template <class T>
+    class ClassScopedSingletonWrapper<T, true> : public ScopedSingletonWrapper
+    {
+    public:
+        ClassScopedSingletonWrapper(const std::string& className)
+            : ScopedSingletonWrapper(className)
+            , singletonPtr_(NULL)
+        {
+        }
+
+        ~ClassScopedSingletonWrapper()
+        {
+            if (singletonPtr_)
+                this->destroy(singletonPtr_);
+        }
+
+        //! Called if the Scope of the Singleton gets active (creates the instance)
+        void activated()
+        {
+            assert(singletonPtr_ == NULL);
+            try
+                { singletonPtr_ = new T(); }
+            catch (const InitialisationAbortedException& ex)
+                { orxout(internal_error) << ex.getDescription() << endl; }
+            catch (...)
+                { orxout(internal_error) << "Singleton creation failed: " << Exception::handleMessage() << endl; }
+        }
+
+        //! Called if the Scope of this Singleton gets deactivated (destroys the instance)
+        void deactivated()
+        {
+            if (singletonPtr_ != NULL)
+            {
+                this->destroy(singletonPtr_);
+                singletonPtr_ = NULL;
+            }
+        }
+
+        //! Destroys the singleton instance - overloaded for Destroyable, calls Destroyable::destroy()
+        void destroy(Destroyable*)
+        {
+            singletonPtr_->destroy();
+        }
+        //! Destroys the singleton instance - overloaded for void*, calls delete
+        void destroy(void*)
+        {
+            delete singletonPtr_;
+        }
+
+    private:
+        T* singletonPtr_;   ///< Unique instance of the singleton class @a T
+    };
+}
+
+#endif /* __ScopedSingletonWrapper_H__ */
Index: code/trunk/src/libraries/network/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/network/CMakeLists.txt	(revision 10622)
+++ code/trunk/src/libraries/network/CMakeLists.txt	(revision 10624)
@@ -34,4 +34,7 @@
   MasterServerComm.cc
   NetworkFunction.cc
+  NetworkFunctionIncludes.cc
+  NetworkFunctionManager.cc
+  NetworkStaticInitializationHandler.cc
   Host.cc
   Server.cc
@@ -43,36 +46,9 @@
 )
 
-SET_SOURCE_FILES(NETWORK_HDR_FILES
-  Client.h
-  ClientConnection.h
-  ClientConnectionListener.h
-  Connection.h
-  FunctionCall.h
-  FunctionCallManager.h
-  #GamestateClient.h
-  GamestateHandler.h
-  GamestateManager.h
-  Host.h
-  LANDiscoverable.h
-  LANDiscovery.h
-  WANDiscoverable.h
-  WANDiscovery.h
-  MasterServerComm.h
-  NetworkChatListener.h
-  NetworkFunction.h
-  NetworkPrecompiledHeaders.h
-  NetworkPrereqs.h
-  Server.h
-  MasterServer.h
-  PeerList.h
-  ServerList.h
-  ServerConnection.h
-  TrafficControl.h
-)
-
 ADD_SUBDIRECTORY(packet)
 ADD_SUBDIRECTORY(synchronisable)
 
 ORXONOX_ADD_LIBRARY(network
+  FIND_HEADER_FILES
   TOLUA_FILES
     Client.h
@@ -90,4 +66,4 @@
     core
   SOURCE_FILES
-    ${NETWORK_SRC_FILES} ${NETWORK_HDR_FILES}
+    ${NETWORK_SRC_FILES}
 )
Index: code/trunk/src/libraries/network/Client.cc
===================================================================
--- code/trunk/src/libraries/network/Client.cc	(revision 10622)
+++ code/trunk/src/libraries/network/Client.cc	(revision 10624)
@@ -45,5 +45,4 @@
 #include "util/Clock.h"
 #include "util/Output.h"
-#include "util/ScopedSingletonManager.h"
 #include "synchronisable/Synchronisable.h"
 #include "packet/Chat.h"
@@ -52,10 +51,11 @@
 #include "core/CoreIncludes.h"
 #include "core/Game.h"
-#include "core/config/CommandLineParser.h"
+#include "core/commandline/CommandLineParser.h"
+#include "core/singleton/ScopedSingletonIncludes.h"
 
 namespace orxonox
 {
 
-  ManageScopedSingleton( Client, ScopeID::Root, true );
+  ManageScopedSingleton( Client, ScopeID::ROOT, false );
 
   /**
@@ -194,14 +194,4 @@
   void Client::connectionClosed()
   {
-    ObjectList<Synchronisable>::iterator it;
-    for(it = ObjectList<Synchronisable>::begin(); it; )
-    {
-      if( it->getSyncMode() != 0x0 )
-        (it++)->destroy();
-      else
-      {
-        ++it;
-      }
-    }
     Game::getInstance().popState();
     Game::getInstance().popState();
Index: code/trunk/src/libraries/network/ClientConnectionListener.cc
===================================================================
--- code/trunk/src/libraries/network/ClientConnectionListener.cc	(revision 10622)
+++ code/trunk/src/libraries/network/ClientConnectionListener.cc	(revision 10624)
@@ -35,5 +35,5 @@
 namespace orxonox
 {
-    RegisterAbstractClass(ClientConnectionListener).inheritsFrom(Class(Listable));
+    RegisterAbstractClass(ClientConnectionListener).inheritsFrom<Listable>();
 
     ClientConnectionListener::ClientConnectionListener()
